﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.Layouts;
using Telerik.WinControls.UI;

namespace _554967
{
    public class CustomTextBoxEditor : PropertyGridTextBoxEditor
    {
        protected override RadElement CreateEditorElement()
        {
            BaseTextBoxEditorElement element = base.CreateEditorElement() as BaseTextBoxEditorElement;
            RadTextBoxItem textBoxItem = element.TextBoxItem;

            if (element.Children.Contains(textBoxItem))
            {
                RadButtonElement button = new RadButtonElement();
                button.Text = "Click to open form";
                button.Click += new EventHandler(button_Click);

                textBoxItem.Alignment = ContentAlignment.MiddleLeft;
                element.Children.Remove(textBoxItem);

                DockLayoutPanel.SetDock(textBoxItem, Telerik.WinControls.Layouts.Dock.Left);
                DockLayoutPanel.SetDock(button, Telerik.WinControls.Layouts.Dock.Right);

                DockLayoutPanel dockLayoutPanel = new DockLayoutPanel();

                dockLayoutPanel.Children.Add(button);
                dockLayoutPanel.Children.Add(textBoxItem);

                element.Children.Add(dockLayoutPanel);
            }

            return element;
        }

        private void button_Click(object sender, EventArgs e)
        {
            Form2 dialog = new Form2();

            dialog.RichTextBox.Text = Convert.ToString(this.Value);

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                this.Value = dialog.RichTextBox.Text;
            }
        }
    }
}
